library websocket;

import 'dart:async';
import 'dart:io' as io;
import './websocket_stub.dart' as stub;

class WebSocket implements stub.WebSocket {
  io.WebSocket _socket;

  WebSocket._(this._socket);

  static FutureOr<WebSocket> connect(
    String url, {
    Iterable<String> protocols,
  }) async {
    return WebSocket._(await io.WebSocket.connect(url, protocols: protocols));
  }

  void add(/*String|List<int>*/ data) => _socket.add(data);

  Future addStream(Stream stream) => _socket.addStream(stream);

  void addUtf8Text(List<int> bytes) => _socket.addUtf8Text(bytes);

  Future close([int code, String reason]) => _socket.close(code, reason);

  int get closeCode => _socket.closeCode;

  String get closeReason => _socket.closeReason;

  String get extensions => _socket.extensions;

  String get protocol => _socket.protocol;

  int get readyState => _socket.readyState;

  void addError(Object error, [StackTrace stackTrace]) =>
      _socket.addError(error, stackTrace);

  Future get done => _socket.done;

  Stream _stream;

  Stream<dynamic /*String|List<int>*/ > get stream =>
      _stream ??= _socket.asBroadcastStream();
}
